/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.worlds.object;

import net.worlds.WorldsException;
import net.worlds.PhysicsController;
import net.worlds.PropChangeHandler;


public class AngularVelocityController extends GameObject{
    private Part part;
    private float value = -1;
    private int timer = 0;
    private PhysicsController controller;
    public AngularVelocityController() throws WorldsException
    {
        super("AngularVelocityController");
        addPropChangeHandler("Parent", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws WorldsException {
                onParentChanged((GameObject) oldValue, (GameObject) value);
                if(value instanceof Part && value != oldValue)
                {
                    if(oldValue instanceof Part)
                        stop();
                    start((Part) value);
                }
            }
        });
        addPropChangeHandler("Velocity", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object v) throws WorldsException {
                value = (float) Math.toRadians((Float) v);
            }
        });
        //x_;
    }
    @Override
    public void addToWorld() throws WorldsException
    {
        super.addToWorld();
        if(getParent() instanceof Part)
            start((Part)getParent());
    }
    private void start(Part p)
    {
        part = p;
        controller = new PhysicsController()
        {
            @Override
            public void run() {
                if(!disabled && timer > 5)
                {
                    part.getBody().wakeUp();
                    if(value != -1 && part != null)
                    {
                        part.getBody().setAngularVelocity(part.getBody().getAngularVelocity() + value);
                    }
                    timer = 0;
                }
                timer++;
            }

        };
        part.addController(controller);
    }
    private void stop()
    {
        value = -1;
        if(part != null)
            part.removeController(controller);
    }
    @Override
    public void destructor() throws WorldsException
    {
        super.destructor();
        stop();
    }
}
