/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.worlds.ui.edge;

import java.awt.Container;
import javax.swing.JComponent;
import javax.swing.SwingUtilities;
import net.worlds.Main;


public class ESwingFrame extends EFrame{
    int componentX;
    int componentY;
    protected JComponent component;
    Container container;
    public ESwingFrame(EComponent parent, int x, int y, int width, int height, JComponent c)
    {
        super(parent, x, y, width, height);
        setComponent(c);
    }
    public ESwingFrame(EComponent parent, int x, int y, int width, int height)
    {
        super(parent, x, y, width, height);
    }
    protected void setComponent(JComponent c)
    {
        if(c != null)
            c.setSize(getWidth()-10, getHeight()-10);
        component = c;
        visible = false;
    }
    public void setVisible(boolean v)
    {
        if(v == visible)
            return;
        visible = v;
        if(Main.noView)
            return;
        if(v)
        {
            if(component == null)
            {
                container.setSize(getWidth() - 10, getHeight() - 10);
                Main.getApplet().addContainer(container);
                container.setLocation(getX() + 5, getY() + 5);
            }
            else
            {
                component.setSize(getWidth() - 10, getHeight() - 10);
                container = Main.getApplet().addComponent(component);
                container.setLocation(getX()+ 5, getY() + 5);
            }
        }
        else
        {
            if(component == null)
            {
                Main.getApplet().removeContainer(container);
            }
            else
            {
                Main.getApplet().removeComponent(container);
                container = null;
            }
        }
    }
    @Override
    public void setWidth(int x)
    {
        super.setWidth(x);
        if(container != null)
        {
            component.setSize(x-10, getHeight() - 10);
            container.setSize(x-10, getHeight() - 10);
        }
    }
    @Override
    public void setHeight(int y)
    {
        super.setHeight(y);
        if(container != null)
        {
            component.setSize(getWidth() - 10, y - 10);
            container.setSize(getWidth() - 10, y - 10);
        }
    }
    @Override
    public void setX(int x)
    {
        super.setX(x);
        if(container != null)
            container.setLocation(getX() + 5, getY() + 5);
    }
    @Override
    public int getX()
    {
        final int sx = super.getX();
        if(container != null && sx + 5 != componentX)
        {
            componentX = sx + 5;
            SwingUtilities.invokeLater(new Runnable()
            {

                public void run() {
                    if(container != null)
                        container.setLocation(sx + 5, container.getY());
                }

            });
        }
        return sx;
    }
    @Override
    public void setY(int y)
    {
        super.setY(y);
        if(container != null)
            container.setLocation(getX(), getY());
    }
    @Override
    public int getY()
    {
        final int sy = super.getY();
        if(container != null && sy != componentY + 5)
        {
            componentY = sy;
            SwingUtilities.invokeLater(new Runnable()
            {

                public void run() {
                    if(container != null)
                        container.setLocation(container.getX(), sy + 5);
                }

            });
        }
        return sy;
    }
}
